VERSION 4.00
Begin VB.Form Queue_Form 
   Caption         =   "Data Queue Testing"
   ClientHeight    =   3135
   ClientLeft      =   870
   ClientTop       =   1545
   ClientWidth     =   4335
   Height          =   3540
   Left            =   810
   LinkTopic       =   "Form1"
   ScaleHeight     =   3135
   ScaleWidth      =   4335
   Top             =   1200
   Width           =   4455
   Begin VB.CheckBox Convert_Check 
      Caption         =   "Convert Data"
      Height          =   255
      Left            =   840
      TabIndex        =   14
      Top             =   2760
      Width           =   1335
   End
   Begin VB.CommandButton Read_Command 
      Caption         =   "Read"
      Height          =   255
      Left            =   3360
      TabIndex        =   13
      Top             =   2760
      Width           =   855
   End
   Begin VB.CommandButton Write_Command 
      Caption         =   "Write"
      Height          =   255
      Left            =   3360
      TabIndex        =   12
      Top             =   2400
      Width           =   855
   End
   Begin VB.CommandButton Close_Command 
      Caption         =   "Close"
      Height          =   255
      Left            =   3360
      TabIndex        =   11
      Top             =   2040
      Width           =   855
   End
   Begin VB.CommandButton Open_Command 
      Caption         =   "Open"
      Height          =   255
      Left            =   3360
      TabIndex        =   10
      Top             =   1680
      Width           =   855
   End
   Begin VB.CommandButton Delete_Command 
      Caption         =   "Delete"
      Height          =   255
      Left            =   2400
      TabIndex        =   9
      Top             =   2040
      Width           =   855
   End
   Begin VB.CommandButton Create_Command 
      Caption         =   "Create"
      Height          =   255
      Left            =   2400
      TabIndex        =   8
      Top             =   1680
      Width           =   855
   End
   Begin VB.TextBox Queue_Text 
      Height          =   285
      Left            =   840
      TabIndex        =   7
      Top             =   2400
      Width           =   1215
   End
   Begin VB.TextBox Lib_Text 
      Height          =   285
      Left            =   840
      MaxLength       =   12
      TabIndex        =   6
      Top             =   2040
      Width           =   1215
   End
   Begin VB.TextBox System_Text 
      Height          =   285
      Left            =   840
      MaxLength       =   10
      TabIndex        =   5
      Top             =   1680
      Width           =   1215
   End
   Begin VB.Frame Data_Frame 
      Caption         =   "Data Queue I/O"
      Height          =   1455
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4095
      Begin VB.TextBox Message_Text 
         Height          =   1095
         Left            =   120
         MaxLength       =   256
         MultiLine       =   -1  'True
         TabIndex        =   1
         Top             =   240
         Width           =   3855
      End
   End
   Begin VB.Label Queue_Label 
      Caption         =   "Queue:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   2400
      Width           =   735
   End
   Begin VB.Label Lib_Label 
      Caption         =   "Library:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   2040
      Width           =   735
   End
   Begin VB.Label System_Label 
      Caption         =   "System:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   1680
      Width           =   735
   End
End
Attribute VB_Name = "Queue_Form"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

'Notes:
'  Using cwbDQ_SetDataAddr to set the buffer address for a
'  data object may not work properly due to VB's constant
'  relocation of memory.  To be on the safe side use
'  cwbDQ_SetData to set the buffer.

'  When using cwbDQ_SetData to setup the data object before
'  a write be certain that you set the dataLength parameter
'  to the exact size of the data you are writing to the
'  queue.  This value may be <= the size of the actual
'  string buffer.

'  If you use separate data objects (which this program doesn't)
'  to read and write to the data queue be certain that if
'  data is converted to EBCDIC in the write object, it
'  should also be converted in the read object, otherwise
'  data conversion errors will result.

Private Declare Function cwbDQ_CreateData _
                        Lib "Cwbdq" () As Long
                        
Private Declare Function cwbDQ_DeleteData _
                        Lib "Cwbdq" _
                        (ByVal dataHandle As Long) As Long

Private Declare Function cwbDQ_Delete _
                           Lib "Cwbdq" _
                           (ByVal qName As String, _
                            ByVal lName As String, _
                            ByVal sName As String, _
                            ByVal errorHandle As Long) As Long

Private Declare Function cwbDQ_Create _
                           Lib "Cwbdq" _
                           (ByVal qName As String, _
                            ByVal lName As String, _
                            ByVal sName As String, _
                            ByVal queueAttr As Long, _
                            ByVal errorHandle As Long) As Long
                                                   
Private Declare Function cwbDQ_CreateAttr _
                           Lib "Cwbdq" () As Long

Private Declare Function cwbDQ_DeleteAttr _
                           Lib "Cwbdq" _
                           (ByVal queueAttr As Long) As Long

Private Declare Function cwbDQ_Close _
                           Lib "Cwbdq" _
                           (ByVal queueHandle As Long) As Long

Private Declare Function cwbDQ_SetConvert _
                           Lib "Cwbdq" _
                           (ByVal dataHandle As Long, _
                            ByVal convert As Long) As Long

Private Declare Function cwbDQ_Open _
                           Lib "Cwbdq" _
                           (ByVal qName As String, _
                            ByVal lName As String, _
                            ByVal sName As String, _
                            ByRef queueHandle As Long, _
                            ByVal errorHandle As Long) As Long

Private Declare Function cwbDQ_Write _
                           Lib "Cwbdq" _
                           (ByVal queueHandle As Long, _
                            ByVal dataHandle As Long, _
                            ByVal commit As Long, _
                            ByVal errorHandle As Long) As Long
                                                  
Private Declare Function cwbDQ_Read _
                           Lib "Cwbdq" _
                           (ByVal queueHandle As Long, _
                            ByVal dataHandle As Long, _
                            ByVal timeout As Long, _
                            ByVal errorHandle As Long) As Long

Private Declare Function cwbDQ_SetDataAddr _
                           Lib "Cwbdq" _
                           (ByVal dataHandle As Long, _
                            ByVal dataString As String, _
                            ByVal dataLength As Long) As Long
                                                        
Private Declare Function cwbDQ_SetData _
                           Lib "Cwbdq" _
                           (ByVal dataHandle As Long, _
                            ByVal dataString As String, _
                            ByVal dataLength As Long) As Long
                                                        
Private Declare Function cwbDQ_GetData _
                           Lib "Cwbdq" _
                           (ByVal dataHandle As Long, _
                            ByVal dataString As String) As Long
                                                        
Dim errHandle As Long
Dim attrHandle As Long
Dim dataHandle As Long
Dim queueHandle As Long

Private Sub Close_Command_Click()
  Dim rc As Long

  If (queueHandle = 0) Then
    MsgBox "Queue not open."
    Exit Sub
  End If
  
  rc = cwbDQ_Close(queueHandle)
  queueHandle = 0
  MsgBox "Close returned " + Str(rc)
  
End Sub

Private Sub Convert_Check_Click()
  Dim rc As Long
  Dim convert As Long
  
  convert = Convert_Check.Value
  
  rc = cwbDQ_SetConvert(dataHandle, convert)
  MsgBox "SetConvert returned " + Str(rc)

End Sub

Private Sub Create_Command_Click()
  Dim rc As Long
  Dim sysName As String
  Dim queueName As String
  Dim libName As String

  sysName = System_Text.Text
  queueName = Queue_Text.Text
  libName = Lib_Text.Text
  
  If (Len(sysName) <= 0) Then
    MsgBox "Must specify system name."
    Exit Sub
  End If
  
  If (Len(queueName) <= 0) Then
    MsgBox "Must specify queue name."
    Exit Sub
  End If
  
  rc = cwbDQ_Create(queueName, libName, sysName, attrHandle, errHandle)
  MsgBox "Create returned " + Str(rc)
  
End Sub

Private Sub Delete_Command_Click()
  Dim rc As Long
  Dim sysName As String
  Dim queueName As String
  Dim libName As String
  
  sysName = System_Text.Text
  queueName = Queue_Text.Text
  libName = Lib_Text.Text
  
  If (Len(sysName) <= 0) Then
    MsgBox "Must specify system name."
    Exit Sub
  End If
  
  If (Len(queueName) <= 0) Then
    MsgBox "Must specify queue name."
    Exit Sub
  End If
  
  rc = cwbDQ_Delete(queueName, libName, sysName, errHandle)
  MsgBox "Delete returned " + Str(rc)

End Sub

Private Sub Form_Load()
  
  errHandle = 0
  queueHandle = 0
  attrHandle = cwbDQ_CreateAttr()
  dataHandle = cwbDQ_CreateData()
  
End Sub

Private Sub Form_Unload(Cancel As Integer)

  Dim rc As Long

  rc = cwbDQ_DeleteData(dataHandle)
  rc = cwbDQ_DeleteAttr(attrHandle)

  If (queueHandle <> 0) Then
    rc = cwbDQ_Close(queueHandle)
    queueHandle = 0
  End If

End Sub

Private Sub Open_Command_Click()

  Dim rc As Long
  Dim sysName As String
  Dim queueName As String
  Dim libName As String

  If (queueHandle <> 0) Then
    MsgBox "Queue already open, close first."
    Exit Sub
  End If
  
  sysName = System_Text.Text
  queueName = Queue_Text.Text
  libName = Lib_Text.Text
  
  If (Len(sysName) <= 0) Then
    MsgBox "Must specify system name."
    Exit Sub
  End If
  
  If (Len(queueName) <= 0) Then
    MsgBox "Must specify queue name."
    Exit Sub
  End If
  
  rc = cwbDQ_Open(queueName, libName, sysName, queueHandle, errHandle)
  MsgBox "Open returned " + Str(rc) + " Handle: " + Str(queueHandle)

End Sub

Private Sub Read_Command_Click()
  Dim rc As Long
  Dim drc As Long
  Static dataString As String
  Dim dataLength As Long
  
  If (queueHandle = 0) Then
    MsgBox "Must open queue to read."
    Exit Sub
  End If

  dataLength = Message_Text.MaxLength
  'Nullify our string
  dataString = String(dataLength, 0)

  rc = cwbDQ_SetData(dataHandle, dataString, dataLength)
  MsgBox "SetData returned " + Str(rc)

  rc = cwbDQ_Read(queueHandle, dataHandle, 0, errHandle)
  MsgBox "Read returned " + Str(rc)

  drc = cwbDQ_GetData(dataHandle, dataString)
  MsgBox "GetData returned " + Str(rc)

  If (rc = 0) Then
    Message_Text.Text = dataString
  End If
  
End Sub

Private Sub Write_Command_Click()

  Dim rc As Long
  Static dataString As String
  Dim dataLength As Long

  If (queueHandle = 0) Then
    MsgBox "Must open queue to write."
    Exit Sub
  End If
  
  dataString = Message_Text.Text
  'Find exact data length
  dataLength = Len(Message_Text.Text)
      
  rc = cwbDQ_SetData(dataHandle, dataString, dataLength)
  MsgBox "SetData returned " + Str(rc)
  
  rc = cwbDQ_Write(queueHandle, dataHandle, 1, errHandle)
  MsgBox "Write returned " + Str(rc)

  If (rc = 0) Then
    Message_Text.Text = ""
  End If

End Sub
